using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq.Expressions;

public class PlayerController : MonoBehaviour
{
	private CursorController cursor;
	private Tower tower;
	private Shop shop;
	private int attackPower = 5;
	private bool attack;
	private float timeToAttack = 0.5f;
	private float timerToAttack = 0f;

	private Weapon[] weapons;
	private int activeWeaponId = 0;
	void Start()
	{
		animation.Play("Idle");
		cursor = FindObjectOfType<CursorController>();
		tower = FindObjectOfType<Tower>();
		shop = FindObjectOfType<Shop>();
		weapons = FindObjectsOfType<Weapon>();

		SetActiveWeapon(1);
	}
	
	void Update()
	{
		if (cursor != null)
		{
			float distanceX = cursor.transform.position.x - transform.position.x;

			if (distanceX > 1&&transform.position.x<10)
			{
				if (!animation.IsPlaying("Walk")) 
				{
					animation.Play("Walk"); 
				}
				transform.position += Vector3.right * Time.deltaTime * 5;
				transform.rotation = Quaternion.Euler(0, 90, 0);
			}else if (distanceX<-1 & transform.position.x >-10)
			{
                if (!animation.IsPlaying("Walk")) 
				{ 
					animation.Play("Walk"); 
				}
                transform.position += Vector3.left * Time.deltaTime * 5;
                transform.rotation = Quaternion.Euler(0, -90, 0);
            }
			else  
			{
				if (Input.GetMouseButtonDown(0) & !animation.IsPlaying("Attack")&&cursor.transform.position.x<-12)
				{
					animation.Play("Attack");
					
                  
                    if (Vector3.Distance(transform.position, tower.transform.position) < 5.5f)
                    {
						attack = true;
                    }
                }

                if (Input.GetMouseButtonDown(0) & cursor.transform.position.x >12&&shop.shopIsOpen == false)
                {
					shop.ShowShopWindow();
                }


                if (!animation.IsPlaying("Idle")&!animation.IsPlaying("Attack"))
				{
                    animation.Play("Idle");
                }
			}

			if(attack == true)
			{
				if (timerToAttack > timeToAttack)
				{
                    tower.Hit(attackPower);
					timerToAttack = 0;
                    attack = false;
				}
				else
				{
					timerToAttack += Time.deltaTime;
				}
			}
		
		}

	
	}

	void ActivateSelectedWeapon()
	{
		foreach (var weapon in weapons)
		{
			if(activeWeaponId == weapon.Id)
			{
				weapon.gameObject.enabled = true;

				attackPower = weapon.AttackPower;
			}
			else
			{
				weapon.gameObject.enabled = false;
			}
		}
	}

	public void SetActiveWeapon(int id)
	{
		activeWeaponId = id;
		ActivateSelectedWeapon();
    }
}
