using FalcoEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class Shop : MonoBehaviour
{
    public AudioClip PurchasedSound;
    public AudioClip NoMoneySound;

    public Button ExitShopButton;
    public Button BuySword2Button;
    public Button BuySword3Button;
    public Button BuySword4Button;
    public Button BuySword5Button;

    public GameObject ShopWindow;
	public bool shopIsOpen = false;

    private CursorController cursor;
	private Wallet wallet;
	private PlayerController playerController;

    void Awake()
    {
        wallet = FindObjectOfType<Wallet>();
        playerController = FindObjectOfType<PlayerController>();
        cursor = FindObjectOfType<CursorController>();

    }
    void Start()
	{
        ExitShopButton.onMouseDown += (UIElement sender, int button, Vector2 cursorPosition) =>
		{
			HideShopwWindow();
		};

        BuySword2Button.onMouseDown += (UIElement sender, int button, Vector2 cursorPosition) =>
        {
            BuyItem(400, 2);
        };
        BuySword3Button.onMouseDown += (UIElement sender, int button, Vector2 cursorPosition) =>
        {
            BuyItem(2000, 3);
        };
        BuySword4Button.onMouseDown += (UIElement sender, int button, Vector2 cursorPosition) =>
        {
            BuyItem(800, 4);
        };
        BuySword5Button.onMouseDown += (UIElement sender, int button, Vector2 cursorPosition) =>
        {
            BuyItem(150, 5);
        };
    }

	public void ShowShopWindow()
	{
		ShopWindow.enabled = true;
		shopIsOpen = true;
		cursor.LockCursor();
	}

    private void HideShopwWindow()
    {
        ShopWindow.enabled = false;
        shopIsOpen = false;
        cursor.LockCursor();
    }
    private void BuyItem(int price,int weaponId)
    {
        if (wallet.Coins > price)
        {
            playerController.SetActiveWeapon(weaponId);
            wallet.Coins -= price;
            wallet.UpdateCoinsText();
            PlaySound(PurchasedSound);
            HideShopwWindow();
        }
        else
        {
            PlaySound(NoMoneySound);
        }
    }
    private void PlaySound(AudioClip sound)
    {
        audioSource.audioClip = sound;
        audioSource.Play();
    }
}
